unit hiPadeg;

interface

uses Windows, Kol, Share, Debug;

const
  LibPadeg = 'Padeg.dll';

const
  ERROR_SUCCESS                      = 0;
  ERROR_INVALID_PADEG                = 1;
  ERROR_INVALID_SEX                  = 2;
  ERROR_INSUFFICIENT_BUFFER          = 3;
  ERROR_IMPOSSIBLE_DEFINE_PADEG      = 4; 
  ERROR_IMPOSSIBLE_DEFINE_SEX        = 5;
  ERROR_IMPOSSIBLE_SET_DICTIONARY    = 6;
  ERROR_IMPOSSIBLE_UPDATE_DICTIONARY = 7;  
  ERROR_INSUFFICIENT_BUFFER_L        = 8;
  ERROR_INSUFFICIENT_BUFFER_F        = 9;
  ERROR_INSUFFICIENT_BUFFER_M        = 10;

type
  PPartsFIO = ^TPartsFIO;
  TPartsFIO = record
    pLastName, pFirstName, pMiddleName : PChar;
    nLastName, nFirstName, nMiddleName : LongInt;
  end;

type
  THIPadeg = class(TDebug)
  private
    FData: TData;
    fLastName, fFirstName, fMiddleName: string;
  public
    _prop_Action: byte;
    _prop_FileName: string;

    _data_FileName: THI_Event;
    _data_LastName: THI_Event;
    _data_FirstName: THI_Event;
    _data_MiddleName: THI_Event;
    _data_Padeg: THI_Event;
    _data_Sex: THI_Event;
    _data_FIO: THI_Event;
    _data_IF: THI_Event;
    _data_Appointment: THI_Event;
    _data_Office: THI_Event;    

    _event_onResult: THI_Event;
    _event_onError: THI_Event;

    destructor Destroy; override;
    procedure _work_doAction0(var _Data: TData; Index: word);
    procedure _work_doAction1(var _Data: TData; Index: word);
    procedure _work_doAction2(var _Data: TData; Index: word);
    procedure _work_doAction3(var _Data: TData; Index: word);
    procedure _work_doAction4(var _Data: TData; Index: word);
    procedure _work_doAction5(var _Data: TData; Index: word);
    procedure _work_doAction6(var _Data: TData; Index: word);
    procedure _work_doAction7(var _Data: TData; Index: word);
    procedure _work_doAction8(var _Data: TData; Index: word);
    procedure _work_doAction9(var _Data: TData; Index: word);
    procedure _work_doAction10(var _Data: TData; Index: word);
    procedure _work_doAction11(var _Data: TData; Index: word);
    procedure _work_doAction12(var _Data: TData; Index: word);
    procedure _work_doAction13(var _Data: TData; Index: word);
    procedure _work_doAction14(var _Data: TData; Index: word);
    procedure _work_doAction15(var _Data: TData; Index: word);
    procedure _var_Result(var _Data: TData; Index: word);
    procedure _var_pLastName(var _Data: TData; Index: word);
    procedure _var_pFirstName(var _Data: TData; Index: word);
    procedure _var_pMiddleName(var _Data: TData; Index: word);

  end;

implementation
//------------------------------------------------------------------------------

function GetFIOPadeg(pLastName, pFirstName, pMiddleName: PChar; bSex: Boolean;
                     nPadeg: LongInt; pResult: PChar; var nLen: LongInt): Integer;
                     stdcall; external LibPadeg name 'GetFIOPadeg';

function GetFIOPadegAS(pLastName, pFirstName, pMiddleName: PChar; nPadeg: LongInt;
                       pResult: PChar; var nLen: LongInt): Integer;
                       stdcall; external LibPadeg name 'GetFIOPadegAS';
                       
function GetFIOPadegFS(pFIO: PChar; bSex: Boolean; nPadeg: LongInt;
                      pResult: PChar; var nLen: LongInt):Integer;
                      stdcall; external LibPadeg name 'GetFIOPadegFS';
                      
function GetFIOPadegFSAS(pFIO: PChar; nPadeg: LongInt; pResult: PChar;
                         var nLen: LongInt):Integer;
                         stdcall; external LibPadeg name 'GetFIOPadegFSAS';
                         
function GetIFPadeg(pFirstName, pLastName: PChar; bSex: Boolean; nPadeg: LongInt;
                    pResult: PChar; var nLen: LongInt): Integer;
                    stdcall; external LibPadeg name 'GetIFPadeg';
                                                                                          
function GetIFPadegFS(pIF: PChar; bSex: Boolean; nPadeg: LongInt;
                      pResult: PChar; var nLen: LongInt): Integer;
                      stdcall; external LibPadeg name 'GetIFPadegFS';
                      
function GetNominativePadeg(pFIO, pResult: PChar; var nLen: LongInt): Integer;
                            stdcall; external LibPadeg name 'GetNominativePadeg';
                            
function GetAppointmentPadeg(pAppointment: PChar; nPadeg: LongInt;
                             pResult: PChar; var nLen: LongInt): Integer;
                             stdcall; external LibPadeg name 'GetAppointmentPadeg';
                             
function GetFullAppointmentPadeg(pAppointment, pOffice: PChar; nPadeg: LongInt;
                                 pResult: PChar; var nLen: LongInt): Integer;
                                 stdcall; external LibPadeg name 'GetFullAppointmentPadeg';
                                 
function GetOfficePadeg(pOffice: PChar; nPadeg: LongInt; pResult: PChar; var nLen: LongInt): Integer;
                        stdcall; external LibPadeg name 'GetOfficePadeg';
                        
function GetSex(pMiddleName: PChar): Integer; stdcall; external LibPadeg name 'GetSex';

function GetPadegID(pFIO: PChar): Integer; stdcall; external LibPadeg name 'GetPadegID';

function GetFIOParts(pFIO: PChar; Parts: PPartsFIO): Integer;
                     stdcall; external LibPadeg name 'GetFIOParts';

function UpdateExceptions: Boolean; stdcall; external LibPadeg name 'GetFIOParts';

function GetExceptionsFileName(pResult: PChar; var nLen: LongInt): Integer;
                               stdcall; external LibPadeg name 'GetExceptionsFileName';
                               
function SetDictionary(FileName: PChar): Boolean; stdcall; external LibPadeg name 'SetDictionary';                                                                                                                                                 

//------------------------------------------------------------------------------

destructor THIPadeg.Destroy;
begin
  FreeData(@FData);
  inherited;
end;
  
procedure THIPadeg._work_doAction0;
var
  pResult: string;
  nLen: LongInt;
  sLastName, sFirstName, sMiddleName: string;
  err: Integer;  
begin
  FreeData(@FData);
  sLastName   := ReadString(_Data, _data_LastName);
  sFirstName  := ReadString(_Data, _data_FirstName);
  sMiddleName := ReadString(_Data, _data_MiddleName);

  nLen := Length(sLastName + sFirstName + sMiddleName) + 10; 
  SetLength(pResult, nLen);

  err := GetFIOPadeg(@sLastName[1], @sFirstName[1], @sMiddleName[1], boolean(ReadInteger(_Data, _data_Sex)),
                     ReadInteger(_Data, _data_Padeg), @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;                
end;

procedure THIPadeg._work_doAction1;
var
  pResult: string;
  nLen: LongInt;
  sLastName, sFirstName, sMiddleName: string;
  err: Integer;  
begin
  FreeData(@FData);
  sLastName   := ReadString(_Data, _data_LastName);
  sFirstName  := ReadString(_Data, _data_FirstName);
  sMiddleName := ReadString(_Data, _data_MiddleName);

  nLen := Length(sLastName + sFirstName + sMiddleName) + 10; 
  SetLength(pResult, nLen);

  err := GetFIOPadegAS(@sLastName[1], @sFirstName[1], @sMiddleName[1],
                       ReadInteger(_Data, _data_Padeg), @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;                
end;

procedure THIPadeg._work_doAction2;
var
  pResult: string;
  nLen: LongInt;
  sFIO: string;
  err: Integer;  
begin
  FreeData(@FData);
  sFIO := ReadString(_Data, _data_FIO);

  nLen := Length(sFIO) + 10; 
  SetLength(pResult, nLen);

  err := GetFIOPadegFS(@sFIO[1], boolean(ReadInteger(_Data, _data_Sex)),
                       ReadInteger(_Data, _data_Padeg), @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;                
end;

procedure THIPadeg._work_doAction3;
var
  pResult: string;
  nLen: LongInt;
  sFIO: string;
  err: Integer;  
begin
  FreeData(@FData);
  sFIO := ReadString(_Data, _data_FIO);

  nLen := Length(sFIO) + 10; 
  SetLength(pResult, nLen);

  err := GetFIOPadegFSAS(@sFIO[1], ReadInteger(_Data, _data_Padeg), @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;  
end;

procedure THIPadeg._work_doAction4;
var
  pResult: string;
  nLen: LongInt;
  sLastName, sFirstName: string;
  err: Integer;  
begin
  FreeData(@FData);
  sLastName   := ReadString(_Data, _data_LastName);
  sFirstName  := ReadString(_Data, _data_FirstName);

  nLen := Length(sLastName + sFirstName) + 10; 
  SetLength(pResult, nLen);

  err := GetIFPadeg(@sFirstName[1], @sLastName[1], boolean(ReadInteger(_Data, _data_Sex)),
                     ReadInteger(_Data, _data_Padeg), @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;    
end;

procedure THIPadeg._work_doAction5;
var
  pResult: string;
  nLen: LongInt;
  sIF: string;
  err: Integer;  
begin
  FreeData(@FData);
  sIF := ReadString(_Data, _data_IF);

  nLen := Length(sIF) + 10; 
  SetLength(pResult, nLen);

  err := GetFIOPadegFS(@sIF[1], boolean(ReadInteger(_Data, _data_Sex)),
                       ReadInteger(_Data, _data_Padeg), @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;           
end;

procedure THIPadeg._work_doAction6;
var
  pResult: string;
  nLen: LongInt;
  sFIO: string;
  err: Integer;  
begin
  FreeData(@FData);
  sFIO := ReadString(_Data, _data_FIO);

  nLen := Length(sFIO) + 10; 
  SetLength(pResult, nLen);

  err := GetNominativePadeg(@sFIO[1], @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;    
end;

procedure THIPadeg._work_doAction7;
var
  pResult: string;
  nLen: LongInt;
  sAppointment: string;
  err: Integer;  
begin
  FreeData(@FData);
  sAppointment := ReadString(_Data, _data_Appointment);

  nLen := Length(sAppointment) + 10; 
  SetLength(pResult, nLen);

  err := GetAppointmentPadeg(@sAppointment[1], ReadInteger(_Data, _data_Padeg), @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;  
end;

procedure THIPadeg._work_doAction8;
var
  pResult: string;
  nLen: LongInt;
  sOffice: string;
  err: Integer;  
begin
  FreeData(@FData);
  sOffice := ReadString(_Data, _data_Office);

  nLen := Length(sOffice) + 10; 
  SetLength(pResult, nLen);

  err := GetOfficePadeg(@sOffice[1], ReadInteger(_Data, _data_Padeg), @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;  
end;

procedure THIPadeg._work_doAction9;
var
  pResult: string;
  nLen: LongInt;
  sAppointment, sOffice: string;
  err: Integer;  
begin
  FreeData(@FData);
  sAppointment := ReadString(_Data, _data_Appointment);
  sOffice := ReadString(_Data, _data_Office);  

  nLen := Length(sAppointment + sOffice) + 10; 
  SetLength(pResult, nLen);

  err := GetFullAppointmentPadeg(@sAppointment[1], @sOffice[1], ReadInteger(_Data, _data_Padeg),
                                 @pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;  
end;

procedure THIPadeg._work_doAction10;
var
  sMiddleName: string;
  res: integer;
begin
  FreeData(@FData);
  sMiddleName := ReadString(_Data, _data_MiddleName);
  res := GetSex(@sMiddleName[1]);
  if res = -1 then
    _hi_onEvent(_event_onError, ERROR_IMPOSSIBLE_DEFINE_SEX)
  else
  begin
    dtInteger(FData, res); 
    _hi_onEvent_(_event_onResult, FData);
  end;      
end;

procedure THIPadeg._work_doAction11;
var
  sFIO: string;
  res: Integer;  
begin
  FreeData(@FData);
  sFIO := ReadString(_Data, _data_FIO);

  res := GetPadegID(@sFIO[1]);
  if res = 0 then
    _hi_onEvent(_event_onError, ERROR_IMPOSSIBLE_DEFINE_PADEG)
  else
  begin    
    dtInteger(FData, res); 
    _hi_onEvent_(_event_onResult, FData);
  end;    
end;

procedure THIPadeg._work_doAction12;
var
  sFIO: string;
  err: Integer;
  Parts: TPartsFIO;    
  dtLastName, dtFirstName, dtMiddleName: TData;
  nLen: integer;
begin

  FreeData(@FData);
  sFIO := ReadString(_Data, _data_FIO);
  fLastName   := '';
  fFirstName  := '';
  fMiddleName := '';    

  nLen := Length(sFIO); 

  GetMem(Parts.pLastName, nLen);
  GetMem(Parts.pFirstName, nLen);
  GetMem(Parts.pMiddleName, nLen);    
TRY  
  Parts.nLastName   := nLen;
  Parts.nFirstName  := nLen;
  Parts.nMiddleName := nLen;

  err := GetFIOParts(@sFIO[1], @Parts);

  if err <> ERROR_SUCCESS then
    case err of
      -3: _hi_onEvent(_event_onError, ERROR_INSUFFICIENT_BUFFER_L); 
      -4: _hi_onEvent(_event_onError, ERROR_INSUFFICIENT_BUFFER_F);
      -5: _hi_onEvent(_event_onError, ERROR_INSUFFICIENT_BUFFER_M);      
    end
  else
  begin    
    fLastName := Parts.pLastName; 
    SetLength(fLastName, Parts.nLastName);
    dtString(dtLastName, fLastName);

    fFirstName := Parts.pFirstName; 
    SetLength(fFirstName, Parts.nFirstName);
    dtString(dtFirstName, fFirstName);
    
    fMiddleName := Parts.pMiddleName; 
    SetLength(fMiddleName, Parts.nMiddleName);
    dtString(dtMiddleName, fMiddleName);

    dtLastName.ldata := @dtFirstName;
    dtFirstName.ldata := @dtMiddleName;
    
    CopyData(@FData, @dtLastName);
 
    _hi_onEvent_(_event_onResult, FData);
  end;
FINALLY
  FreeMem(Parts.pLastName);   
  FreeMem(Parts.pFirstName);
  FreeMem(Parts.pMiddleName);
END;      
end;

procedure THIPadeg._work_doAction13;
var
  fn: string;
begin
  FreeData(@FData);
  fn := ReadString(_Data, _data_FileName, _prop_FileName);
  if SetDictionary(@fn[1]) then
  begin
    dtString(FData, fn);
    _hi_onEvent_(_event_onResult, FData);
  end
  else
    _hi_onEvent(_event_onError, ERROR_IMPOSSIBLE_SET_DICTIONARY);    
end;

procedure THIPadeg._work_doAction14;
begin
  if UpdateExceptions then
    _hi_onEvent(_event_onResult)
  else
    _hi_onEvent(_event_onError, ERROR_IMPOSSIBLE_UPDATE_DICTIONARY);    
end;

procedure THIPadeg._work_doAction15;
var
  pResult: string;
  nLen: LongInt;
  err: Integer;  
begin
  FreeData(@FData);

  nLen := MAX_PATH; 
  SetLength(pResult, nLen);

  err := GetExceptionsFileName(@pResult[1], nLen);
  if err <> ERROR_SUCCESS then
    _hi_onEvent(_event_onError, abs(err))
  else
  begin    
    SetLength(pResult, nLen);
    dtString(FData, pResult); 
    _hi_onEvent_(_event_onResult, FData);
  end;  
end;

procedure THIPadeg._var_Result;
begin
  _Data := FData;
end;

procedure THIPadeg._var_pLastName;
begin
  dtString(_Data, fLastName); 
end;

procedure THIPadeg._var_pFirstName;
begin
  dtString(_Data, fFirstName);
end;

procedure THIPadeg._var_pMiddleName;
begin
  dtString(_Data, fMiddleName);
end;

end.